// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// CircleEdgeDistanceDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CircleEdgeDistance.h"
#include "CircleEdgeDistanceDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleEdgeDistanceDlg _CAO

CCircleEdgeDistanceDlg::CCircleEdgeDistanceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCircleEdgeDistanceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCircleEdgeDistanceDlg)
	m_color = -1;
	m_startpos = -1;
	m_edgepoint = -1;
	m_threshold = 70;
	m_linewidth = 0;
	m_linenum = 50;
	m_weight = 10.0;
	m_origin = -1;
	m_result = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_PI = 3.14159265358979;
	m_blnVideoOpened = false;

}

void CCircleEdgeDistanceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCircleEdgeDistanceDlg)
	DDX_CBIndex(pDX, IDC_EDGECOLOR, m_color);
	DDX_CBIndex(pDX, IDC_EDGESTARTPOS, m_startpos);
	DDX_CBIndex(pDX, IDC_EDGEPOINT, m_edgepoint);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxLong(pDX, m_threshold, 0, 100);
	DDX_Text(pDX, IDC_LINEWIDTH, m_linewidth);
	DDX_Text(pDX, IDC_LINENUM, m_linenum);
	DDX_Text(pDX, IDC_WEIGHT, m_weight);
	DDX_CBIndex(pDX, IDC_ORIGIN, m_origin);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCircleEdgeDistanceDlg, CDialog)
	//{{AFX_MSG_MAP(CCircleEdgeDistanceDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SETEDGESCANCIRCLE, OnSetedgescancircle)
	ON_BN_CLICKED(IDC_REDRAW, OnRedraw)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleEdgeDistanceDlg bZ[W nh

BOOL CCircleEdgeDistanceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	// ----------------------------------------------------------------------
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxEdge.CreateInstance( __uuidof( FvxEdge ) ); 
		m_FvxCalcData.CreateInstance( __uuidof( FvxCalcData ) ); 
		m_EdgeScanCircle.CreateInstance( __uuidof( FvCircle ) ); 

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// J荞ݖ
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);

		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage );

		// GbWo~̏lݒ
		m_EdgeScanCircle->Putx( 290 );
		m_EdgeScanCircle->Puty( 240 );
		m_EdgeScanCircle->Putradius( 120 );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGECOLOR );
		pcmb->AddString( "" );		// WHITE_TO_BLACK
		pcmb->AddString( "" );		// BLACK_TO_WHITE
		pcmb->AddString( "ɐ" );		// ALL_COLOR
		m_color = 2;

		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGEPOINT );
		pcmb->AddString( "ő_" );		// POINT_PEAK lő̈ʒuGbWƂ܂
		pcmb->AddString( "ŏ̓_" );		// POINT_1ST lԍŏɉzʒuGbWƂ܂
		m_edgepoint = 0;

		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGESTARTPOS );
		pcmb->AddString( "SO" );	// FROM_START n_ʒuGbW܂
		pcmb->AddString( "OS" );	// FROM_END I_ʒuGbW܂
		m_startpos = 0;

		pcmb = ( CComboBox* )GetDlgItem( IDC_ORIGIN );
		pcmb->AddString( "o~̒S" );
		pcmb->AddString( "GbW狁߂~̒S" );
		m_origin = 1;

		UpdateData(FALSE); 

		ApplyChanges();
		DrawEdgeScanLine();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImage);

			try	{

				// 捞
				m_FvxVideo->GrabSync(m_FvxImage);

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage);
		ApplyChanges();
		DrawEdgeScanLine();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CCircleEdgeDistanceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CCircleEdgeDistanceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CCircleEdgeDistanceDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCircleEdgeDistanceDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if ( m_FvxDisplayEx != NULL ){

		CWnd *pwnd;
		CRect rect;

		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
		pwnd->GetWindowRect( rect );

		// XN[WNCAgWɕϊ
		ScreenToClient( rect );

		// FvxDisplayEx̃TCYύX
		pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

	}

}

void CCircleEdgeDistanceDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}

// 摜荞
void CCircleEdgeDistanceDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage );
	
}

// 摜t@CǍ
void CCircleEdgeDistanceDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if (( m_FvxImage->GetBitPerPixel()!=8 ) || ( m_FvxImage->GetImageType ()!=imageGray )){

			MessageBox("8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage->PutBitPerPixel( 8 );
            m_FvxImage->PutImageType( imageGray );
            m_FvxImage->PutImageWidth( 512 );
            m_FvxImage->PutImageHeight( 480 );

		}

		m_FvxDisplayEx->DrawImage( m_FvxImage );
	}
}

void CCircleEdgeDistanceDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}

}

// o~ݒ
void CCircleEdgeDistanceDlg::OnSetedgescancircle() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // ݒ_CAȌl߂Ă܂
	m_FvxROI->SetCircle( m_EdgeScanCircle );
    
    // FvxROIgČo~I_CAOo܂
    m_FvxROI->PutUseCircle( TRUE );
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->PutUseRectangle( FALSE );
    
    long lngOK = 0;
    m_FvxROI->MakeROIDialog( m_FvxImage, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckCircle() == 1 )) {
        m_FvxROI->GetCircle( m_EdgeScanCircle );
        
        ApplyChanges();
        DrawEdgeScanLine();
	}
}

void CCircleEdgeDistanceDlg::OnRedraw() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    if ( ApplyChanges() == -1) return;
    DrawEdgeScanLine();
	
}

// o~ƁA̒SLт錟o̕`
void CCircleEdgeDistanceDlg::DrawEdgeScanLine()
{

	IFvLineSegmentPtr pLineSeg(__uuidof(FvLineSegment));
    double dblRad = 0;
    
    m_FvxDisplayEx->ClearOverlay(-1);
    
    // GbWo`
    m_FvxDisplayEx->PutPenColor(0x8080FF);
    m_FvxDisplayEx->DrawData( 0, m_EdgeScanCircle );
    pLineSeg->Putxs( m_EdgeScanCircle->Getx() );
    pLineSeg->Putys( m_EdgeScanCircle->Gety() );
    dblRad = 2 * m_PI / m_FvxEdge->GetLineNum();	  // Pʂ̓WA
    for ( int i = 0 ; i < m_FvxEdge->GetLineNum() ; i++ ) {
        pLineSeg->Putxe( pLineSeg->Getxs() + cos(dblRad * i) * m_EdgeScanCircle->Getradius() );
        pLineSeg->Putye( pLineSeg->Getys() + sin(dblRad * i) * m_EdgeScanCircle->Getradius() );
        m_FvxDisplayEx->DrawData( 0, pLineSeg );
	}
}

void CCircleEdgeDistanceDlg::DrawCrossMark(double dbl_x, double dbl_y)
{

	IFvLineSegmentPtr pLineSeg(__uuidof(FvLineSegment));

    pLineSeg->Putxs( dbl_x - 5 );
    pLineSeg->Putys( dbl_y - 5 );
    pLineSeg->Putxe( dbl_x + 5 );
    pLineSeg->Putye( dbl_y + 5 );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
    pLineSeg->Putxs( dbl_x + 5 );
    pLineSeg->Putys( dbl_y - 5 );
    pLineSeg->Putxe( dbl_x - 5 );
    pLineSeg->Putye( dbl_y + 5 );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );

}

// eRg[ɓ͂ꂽݒl̓Kp
int CCircleEdgeDistanceDlg::ApplyChanges()
{
	if (!UpdateData(TRUE)) return -1;
		
	IFvCountPtr aa(__uuidof(FvCount));

	// o
    if ( m_linenum < 0 ) {
		MessageBox("o0ȏŐݒ肵Ă","G[", MB_ICONWARNING | MB_OK);
        return -1;
	}
	m_FvxEdge->PutLineNum( m_linenum );
    
    // 臒l
    if (( m_threshold < 0 ) || ( m_threshold > 100 )) {
		MessageBox("臒l 0`100 ̊ԂŐݒ肵Ă","G[", MB_ICONWARNING | MB_OK);
        return -1;
	}
	m_FvxEdge->PutThresh( m_threshold );
    
    // Е
    if ( m_linewidth < 0 ) {
		MessageBox("Е͂OȏŐݒ肵Ă","G[", MB_ICONWARNING | MB_OK);
        return -1;
	}
	m_FvxEdge->PutLineWidth ( m_linewidth );
   
    m_FvxEdge->PutEdgeColor( (EDGE_COLOR_TYPE )m_color );				 // GbWɐ
    m_FvxEdge->PutStartPosition( (START_POSITION_TYPE )m_startpos );	 // o
    m_FvxEdge->PutEdgePoint( ( EDGE_POINT_TYPE )m_edgepoint );			 // GbWʒu

	return 0;

}

// s
void CCircleEdgeDistanceDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	IFvCirclePtr pCircle(__uuidof(FvCircle));
	IFvPointGroup2Ptr pPointGroup(__uuidof(FvPointGroup));
	IFvLineSegmentPtr pLineSeg(__uuidof(FvLineSegment));
    IFvPointPtr pOrigin(__uuidof(FvPoint));	// GbWƂ̋𑪂_i~̒Sj
        
    // I[o[CNA
	m_FvxDisplayEx->ClearOverlay(-1);

    // p[^KpB
    // ̓p[^ɃG[vI
    if ( ApplyChanges() == -1 ) return;

	// ʏo͏
	m_result =  "";
	UpdateData(FALSE);

    // o~`
    m_FvxDisplayEx->PutPenColor(0x8080FF);
    m_FvxDisplayEx->DrawData( 0, m_EdgeScanCircle );
    DrawCrossMark( m_EdgeScanCircle->Getx(), m_EdgeScanCircle->Gety());
    
    // ----------------------------------------------------------------
    // ԌvJn
    m_FvxPerformanceCounter->StartCount();
    
    try {

		// GbWos
		long lngCount = 0;			// GbW
		m_FvxEdge->Execute( m_FvxImage, m_EdgeScanCircle, &lngCount );

		// GbWƉ~͐ŕ`
		m_FvxDisplayEx->PutPenColor(0xFF0000);
    
		// oꂽGbW_W̎擾
		m_FvxEdge->GetResult( 0, pPointGroup );
    
		// oXĝ߂ɃGbW_WFvxCalcDataɃZbg
		m_FvxCalcData->SetPoint( 0, pPointGroup );
    
		for ( long i = 0; i < pPointGroup->GetCount(); i++ ) {
			// GbW_\
			DrawCrossMark( pPointGroup->Item2(i)->Getx(), pPointGroup->Item2(i)->Gety() );
		}
			
		// Rȏ̃GbWA~̃oXgs
		if ( pPointGroup->GetCount() > 2 ) {
			m_FvxCalcData->CalcCircle_Robust( pPointGroup->GetCount(), m_weight );
			m_FvxCalcData->CalcCircle_GetResult( pCircle );
        
			m_FvxDisplayEx->DrawData( 0, pCircle );
			DrawCrossMark( pCircle->Getx(), pCircle->Gety() );
        
			m_result.Format("~S : ( %.1f , %.1f )\r\n~a : %.1f",pCircle->Getx(),pCircle->Gety(),pCircle->Getradius());
		}else { 
			MessageBox("GbWȂ܂","GbWo", MB_ICONWARNING | MB_OK);
			return;
		}

		// ǂ̉~̒S̋𑪂邩
		if ( m_origin == 0 ) {
			// o~̒S
			pOrigin->Putx( m_EdgeScanCircle->Getx());
			pOrigin->Puty( m_EdgeScanCircle->Gety());
		} else {	
			// GbW狁߂_̒S
			pOrigin->Putx( pCircle->Getx());
			pOrigin->Puty( pCircle->Gety());
		}

		// PԖڂ̃GbW_ƁA~̒SƂ̋lƂĐݒ
		double dblDistance  = sqrt(pow((pOrigin->Getx() - pPointGroup->Item2(0)->Getx()), 2) + pow((pOrigin->Gety() - pPointGroup->Item2(0)->Gety()),2));
		double dblMaxDistance = dblDistance;				// ő勗
		double dblMinDistance = dblDistance;				// ŏ
		long   lngMaxDistNo = 0;							// ő勗ƂȂ_̔ԍ
		long   lngMinDistNo = 0;							// ŏƂȂ_̔ԍ
    
		for ( i = 1; i < pPointGroup->GetCount();i++ ) {

			// ~̒SƁAGbW_Ƃ̋vZ
			dblDistance =sqrt(pow((pOrigin->Getx() - pPointGroup->Item2(i)->Getx()),2) + pow((pOrigin->Gety() - pPointGroup->Item2(i)->Gety()),2));
        
			// ŏlEől̃sbNAbv
			if ( dblMaxDistance < dblDistance ) {
				dblMaxDistance = dblDistance;
				lngMaxDistNo = i;
			}
			if ( dblMinDistance > dblDistance ) {
				dblMinDistance = dblDistance;
				lngMinDistNo = i;
			}
		}
			
		m_FvxDisplayEx->PutPenColor(0x00C4FF);
    
		// Ső勗_܂ł`
		pLineSeg->Putxs(pOrigin->Getx());
		pLineSeg->Putys(pOrigin->Gety());
		pLineSeg->Putxe(pPointGroup->Item2(lngMaxDistNo)->Getx());
		pLineSeg->Putye(pPointGroup->Item2(lngMaxDistNo)->Gety());
		m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
		// Sŏ_܂ł`
		pLineSeg->Putxe( pPointGroup->Item2(lngMinDistNo)->Getx());
		pLineSeg->Putye( pPointGroup->Item2(lngMinDistNo)->Gety());
		m_FvxDisplayEx->DrawData( 0, pLineSeg );
		CString szStr;
		szStr.Format("\r\nŏ : %.2f\r\nő勗 : %.2f",dblMinDistance,dblMaxDistance);
		m_result = m_result + szStr;
		// ----------------------------------------------------------------

		// ԌvI
	    double dblTime = 0;			// 
		m_FvxPerformanceCounter->StopCount( &dblTime );
		szStr.Format("S : %.2fms\r\n\r\n",dblTime);
		m_result =  szStr + m_result;
    
	} catch ( _com_error &e) {

		CString szErr;
	    long lngErr = 0;
		m_FvxEdge->GetErrReport( &lngErr );

		if (lngErr!= 0) {

			switch ( lngErr ) {
			case 0:
				szErr.Format("G[");
				break;
			case 4005:
				szErr.Format("p[^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 4006:
				szErr.Format("̌^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 4007:
				szErr.Format("NULLw肳Ă܂Berr_no = %d", lngErr );
				break;
			case 4013:
				szErr.Format("̈悪w肳Ă܂Berr_no = %d", lngErr );
				break;
			default:
				szErr.Format("sȃG[ err_no = %d", lngErr );
				break;
			}
			MessageBox(szErr,"G[", MB_ICONWARNING | MB_OK);
		} else {
		    m_FvxCalcData->GetErrReport( &lngErr );
			if (lngErr!= 0) {
				switch ( lngErr ) {
				case 0:
					szErr.Format("G[");
					break;
				case 1605:
					szErr.Format("p[^Ⴂ܂Berr_no = %d", lngErr );
					break;
				case 1606:
					szErr.Format("̌^Ⴂ܂Berr_no = %d", lngErr );
					break;
				case 1607:
					szErr.Format("NULLw肳Ă܂Berr_no = %d", lngErr );
					break;
				case 1610:
					szErr.Format("̊mۂɎs܂Berr_no = %d", lngErr );
					break;
				case 1650:
					szErr.Format("vZs\łBerr_no = %d", lngErr );
					break;
				default:
					szErr.Format("sȃG[ err_no = %d", lngErr );
					break;
				}
				MessageBox(szErr,"G[", MB_ICONWARNING | MB_OK);

			} else {
				MessageBox(e.Description(),"G[", MB_ICONWARNING | MB_OK);
			}
		}
	}

	UpdateData(FALSE);
}

BOOL CCircleEdgeDistanceDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}	
	}
	return CDialog::PreTranslateMessage(pMsg);
}
